/******************************************************************************

Copyright 2003, 2004 Christian Gollan

This file is part of the W2D package.

The W2D package is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

The W2D package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with the W2D package; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************************/

#define DIS_class_kNN 0
#define DIS_class_KD  1
#define DIS_verbose_out 256
#define DIS_verbose_matrix 512
#define DIS_verbose_calc 1024

typedef struct {
  int train_nr;
  int test_nr;
  int test_counter;
  int train_class;
  int test_class;
  double* disfield;
}DISELEMENT;

typedef struct {
  DISELEMENT* row;
  int k;
  int counter;
  int disrows;
  int discolumns;
  int class_counter;
  int* class_matrix;
  int* class_field;
  int class_field_length;
  int disfield_nr;
  unsigned int classifier_type;
  double* variance_field;
}DISDAT;

DISDAT DIS_read_disdat_file(char *);
int DIS_disdat_set_variance(DISDAT* ,char* ,double );
int DIS_disdat_calc(DISDAT);
int DIS_disdat_classifier(DISDAT);
int DIS_disdat_free(DISDAT);
int DIS_disdat_print(DISDAT);
int DIS_disdat_swap_disfield(DISDAT*,int);
int DIS_disdat_sym_distance(DISDAT*);
DISDAT DIS_disdat_copy(DISDAT);
int DIS_disdat_print_best_ER(DISDAT);
