/******************************************************************************

Copyright 2003, 2004 Christian Gollan

This file is part of the W2D package.

The W2D package is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

The W2D package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with the W2D package; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************************/

#define W2D_W   101
#define W2D_HM  102
#define W2D_SA  103
#define W2D_IDM 104
#define W2D_NO 105
#define W2D_HMD 106
#define W2D_IDM3 107
#define W2D_HUNG 108
#define W2D_TD 109

#define W2D_pen 500             //dis_modes for penaltys have to be in the range 500 - 699
#define W2D_len 501
#define W2D_pen2 502
#define W2D_penborder 503
#define W2D_len2 504
#define W2D_null 505
#define W2D_pixelthreshold 506
#define W2D_pixelthresholdmin 507
#define W2D_pixeldismove 508

#define W2D_penwarp 700         //dis_modes for penaltys with file data have to be in the range 700 - 999
#define W2D_penvar 701
#define W2D_euc2rec3x3var 702
#define W2D_penwarptry 999

#define W2D_euc2 1000		//dis_modes with data have to be in the range 1000 - 1999 
#define W2D_abs 1001
#define W2D_euc2rec3x3 1002
#define W2D_euc2rec5x5 1003
#define W2D_euc2bin3x3 1004
#define W2D_euc2bin5x5 1005
#define W2D_warpsum 1006
#define W2D_absrec3x3 1007
#define W2D_euc3 1008
#define W2D_euc2thresholdrec3x3 1009 
#define W2D_euc3rec3x3 1010
#define W2D_euc2rec7x7 1011
#define W2D_euc2rec9x9 1012
#define W2D_euc2rec11x11 1013
#define W2D_tan2rec3x3 1014

typedef struct _KEYWORD
{
  char *string;
  char *type;
  int integer;
}
KEYWORD;

static const KEYWORD keylist[] = {
  {"NO", "W2D_alg", W2D_NO},
  {"WW2DHM", "W2D_alg", W2D_W},
  {"P2DHM", "W2D_alg", W2D_HM},
  {"P2DHMD", "W2D_alg", W2D_HMD},
  {"SA2DHM", "W2D_alg", W2D_SA},
  {"ID", "W2D_alg", W2D_IDM},
  {"HUNG","W2D_alg",W2D_HUNG},
  {"TD","W2D_alg",W2D_TD},
  {"ID3", "W2D_alg", W2D_IDM3},
  {"euc2", "W2D_dis_mode", W2D_euc2},
  {"euc3", "W2D_dis_mode", W2D_euc3},  
  {"euc2rec3x3", "W2D_dis_mode", W2D_euc2rec3x3},
  {"euc2rec5x5", "W2D_dis_mode", W2D_euc2rec5x5},
  {"euc2rec7x7", "W2D_dis_mode", W2D_euc2rec7x7},
  {"euc2rec9x9", "W2D_dis_mode", W2D_euc2rec9x9},
  {"euc2rec11x11", "W2D_dis_mode", W2D_euc2rec11x11},
  {"euc2bin3x3", "W2D_dis_mode", W2D_euc2bin3x3},
  {"euc2bin5x5", "W2D_dis_mode", W2D_euc2bin5x5},
  {"abs", "W2D_dis_mode", W2D_abs},
  {"absrec3x3", "W2D_dis_mode", W2D_absrec3x3},
  {"euc3rec3x3", "W2D_dis_mode", W2D_euc3rec3x3},
  {"euc2thresholdrec3x3", "W2D_dis_mode", W2D_euc2thresholdrec3x3},  
  {"pen", "W2D_dis_mode", W2D_pen},
  {"pen2", "W2D_dis_mode", W2D_pen2},
  {"penborder", "W2D_dis_mode", W2D_penborder},
  {"pixelthreshold", "W2D_dis_mode", W2D_pixelthreshold},
  {"pixelthresholdmin", "W2D_dis_mode", W2D_pixelthresholdmin},
  {"pixeldismove", "W2D_dis_mode", W2D_pixeldismove},
  {"len", "W2D_dis_mode", W2D_len},
  {"len2", "W2D_dis_mode", W2D_len2},
  {"warpsum", "W2D_dis_mode", W2D_warpsum},
  {"penwarp", "W2D_dis_mode", W2D_penwarp},
  {"penvar", "W2D_dis_mode", W2D_penvar},
  {"penwarptry", "W2D_dis_mode", W2D_penwarptry},
  {"euc2rec3x3var", "W2D_dis_mode", W2D_euc2rec3x3var},
  {"null", "W2D_dis_mode", W2D_null},
  {"file","IMG_mode", IMG_file},
  {"image", "IMG_mode", IMG_image},
  {"nullimg", "IMG_mode", IMG_nullimg},
  {"penalty", "IMG_mode", IMG_penalty},
  {"sobelv", "IMG_mode", IMG_sobelv},
  {"sobelh", "IMG_mode", IMG_sobelh},
  {"sobeld", "IMG_mode", IMG_sobeld},
  {"sobelv+", "IMG_mode", IMG_sobelvplus},
  {"sobelh+", "IMG_mode", IMG_sobelhplus},
  {"sobeld+", "IMG_mode", IMG_sobeldplus},
  {"sobelvj", "IMG_mode", IMG_sobelvjaehne},
  {"sobelhj", "IMG_mode", IMG_sobelhjaehne},
  {"sobeldj", "IMG_mode", IMG_sobeldjaehne},
  {"laplace", "IMG_mode", IMG_laplace},
  {"posx","IMG_mode",IMG_position_x},
  {"posy","IMG_mode",IMG_position_y},
  {NULL, NULL, -1}
};

double W2D_NOTHING(IMG, IMG, int* );
double W2DEUC_distance (IMG, IMG, int* );
double W2Deuclid_distance (double *, double *, int);
double W2D_img_dis_from_warp (IMG, IMG, int *);
double W2D_img_dis_without_penalty_from_warp (IMG, IMG, int *);
double pixel_distance (int, int, int, int, int, int, IMG, IMG);
double W2DIDM_distance(IMG, IMG, int *);
double W2DIDM3_distance(IMG, IMG, int *);
int W2D_print_warp_data (int *,int, int);
int W2D_calculate_penvar(IMG_list*,IMG_list*,double W2D_function(IMG,IMG,int*),int);
int W2D_calculate_warpsum(IMG_list*,IMG_list*,double W2D_function(IMG,IMG,int*),int);
int W2D_calculate_dis5x5_var(IMG_list*,IMG_list*, double W2D_function(IMG,IMG,int*));
