/******************************************************************************

Copyright 2003, 2004 Christian Gollan

This file is part of the W2D package.

The W2D package is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

The W2D package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with the W2D package; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

******************************************************************************/

#include "config.h"
#ifdef USE_GDlib
#ifdef USE_X11lib
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#endif
#include <gd.h>
#include <gdfontl.h>
#include "IMG.h"

typedef struct _IMG_GD
{
  gdImagePtr gd_image;
  double max_color;
  double min_color;
  unsigned long colormap[256];
  #ifdef USE_X11lib
  Display *dis;
  Window win;
  GC my_gc;
  #endif
 #ifndef USE_X11lib
  void* dis;
  #endif
}
IMG_GD;
int IMG_GD_draw_img (IMG_GD*, IMG);
int IMG_GD_draw_warping_images(IMG_GD *,IMG , IMG, int *,char *);
int IMG_GD_W2D_draw (IMG_GD *, double *, double *, int *, int, int, char *);
int IMG_X_draw (IMG_GD *);
int IMG_GD_save (IMG_GD *, char *);
int IMG_GD_save_img_png(IMG, char* );
int IMG_GD_save_warped_img_png(IMG, IMG, int*, char* );
int IMG_GD_min_max_color_img_list(IMG_GD*, IMG_list*);
int IMG_GD_destroy (IMG_GD*);
#endif //USE_GDlib
